RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.even
	.data
hexchr:
	.dc.b 97, 98, 99,100,101,102, 56, 57
	.dc.b 65, 66, 67, 68, 69, 70, 48, 49
	.dc.b 50, 51, 52, 53, 54, 55
hexdat:
	.dc.b 10, 11, 12, 13, 14, 15,  8,  9
	.dc.b 10, 11, 12, 13, 14, 15,  0,  1
	.dc.b  2,  3,  4,  5,  6,  7

	.text

	.even
	.global _qp_line
_qp_line:
	movem.l	d3/a3/a4,-(sp)
	move.l	16(sp),a4	*obuf
	move.l	a4,d3
	subq.l	#1,d3
	move.l	20(sp),a3	*ibuf
	lea.l	hexdat(OPC),a2	*hexdat

chr_lp:
	move.b	(a3)+,d0
	beq	delspc_lp

	cmp.b	#'=',d0
	bne	normalchr
	movea.l	a3,a0

*getcode
	movea.l	a2,a1
	moveq.l	#21,d2
	move.b	(a0)+,d1
	moveq.l	#0,d0

high_lp:
	cmp.b	-(a1),d1
	beq	high_ok
	dbra	d2,high_lp
	bra	badcode

high_ok:
	move.b	(a2,d2.w),d0
	movea.l	a2,a1
	moveq.l	#21,d2
	move.b	(a0)+,d1

low_lp:
	cmp.b	-(a1),d1
	beq	codeok
	dbra	d2,low_lp

badcode:
	move.b	(a3),d0
	cmp.b	#10,d0		*LF
	beq	softbreak
	cmp.b	#' ',d0		*SPC
	beq	softbreak
	cmp.b	#9,d0		*TAB
	beq	softbreak
	moveq.l	#-1,d0
	bra	qp_ret

codeok:
	lsl.b	#4,d0
	or.b	(a2,d2.w),d0

	addq.w	#2,a3
	move.l	a4,d3

normalchr:
	move.b	d0,(a4)+
	bra	chr_lp

delspc_lp:
	move.b	-(a4),d0
	cmp.l	a4,d3
	bcc	delspc_end
	cmp.b	#10,d0
	beq	delspc_lp
	cmp.b	#' ',d0
	beq	delspc_lp
	cmp.b	#9,d0
	beq	delspc_lp

delspc_end:
	addq.w	#1,a4
	move.b	#10,(a4)+	*LF

softbreak:
	move.l	a4,d0
	sub.l	16(sp),d0

qp_ret:
	movem.l	(sp)+,d3/a3/a4
	rts

	.even
	.end
